import { Extension } from '../../types';
/**
 * Creates a static copy button that can be added to the overlays of an editor or code
 * block. The `firstChild` of the element returned is the button itself.
 */
declare const createCopyButton: () => Element;
/**
 * Extension that adds a copy button to the editor. Probably best used with a read-only
 * editor. Requires styles from `solid-prism-editor/copy-button.css` to work.
 */
declare const copyButton: () => Extension;
export { createCopyButton, copyButton };
