import { template } from "solid-js/web";
import { d as doc } from "../../core-KRqi5ptr.js";
import { s as setSelection } from "../../local-DVlaAAgt.js";
const createCopyButton = /* @__PURE__ */ template(
  '<div style=display:flex;align-items:flex-start;justify-content:flex-end><button type=button dir=ltr style=display:none class=pce-copy aria-label=Copy><svg width=1.2em aria-hidden=true viewBox="0 0 16 16" overflow=visible stroke-linecap=round fill=none stroke=currentColor><rect x=4 y=4 width=11 height=11 rx=1 /><path d="m12 2a1 1 0 00-1-1H2A1 1 0 001 2v9a1 1 0 001 1">'
);
const copyButton = () => (editor) => {
  const container = createCopyButton();
  const btn = container.firstChild;
  btn.addEventListener("click", () => {
    btn.setAttribute("aria-label", "Copied!");
    if (!navigator.clipboard?.writeText(editor.extensions.folding?.fullCode ?? editor.value)) {
      editor.textarea.select();
      doc.execCommand("copy");
      setSelection(editor, 0);
    }
  });
  btn.addEventListener("pointerenter", () => btn.setAttribute("aria-label", "Copy"));
  return container;
};
export {
  copyButton,
  createCopyButton
};
//# sourceMappingURL=index.js.map
