import { createComputed, onCleanup } from "solid-js";
import { a as addTextareaListener, u as updateNode, d as getLineBefore, h as getLineEnd, j as getPosition, k as scrollToEl } from "../local-DVlaAAgt.js";
import { template } from "solid-js/web";
const cursorTemplate = /* @__PURE__ */ template(
  "<div style=position:absolute;top:0;opacity:0;padding-right:inherit> <span><span></span> "
);
const cursorPosition = () => (editor) => {
  const container = cursorTemplate();
  const [before, span] = container.childNodes;
  const [cursor, after] = span.childNodes;
  const scrollIntoView = () => scrollToEl(editor, cursor);
  const remove = addTextareaListener(editor, "input", (e) => {
    if (/history/.test(e.inputType)) scrollIntoView();
  });
  createComputed(() => {
    const selection = editor.selection();
    const value = editor.value;
    const position = selection[selection[2] < "f" ? 0 : 1];
    const index = editor.activeLine;
    const activeLine = editor.lines[index];
    if (index) {
      updateNode(before, getLineBefore(value, position));
      updateNode(after, value.slice(position, getLineEnd(value, position)) + "\n");
      if (container.parentNode != activeLine) activeLine.prepend(container);
    }
  });
  onCleanup(() => {
    delete editor.extensions.cursor;
    container.remove();
    remove();
  });
  editor.extensions.cursor = {
    scrollIntoView,
    getPosition: () => getPosition(editor, cursor)
  };
};
export {
  cursorPosition
};
//# sourceMappingURL=cursor.js.map
