import { onCleanup } from "solid-js";
import { g as getStyleValue } from "../other-EdiSn7BB.js";
const overscroll = () => (editor) => {
  if (window.ResizeObserver) {
    const wrapper = editor.wrapper;
    const container = editor.container;
    const observer = new ResizeObserver(() => {
      wrapper.style.paddingBottom = `${container.clientHeight - getStyleValue(wrapper, "marginBottom") - getStyleValue(wrapper, "lineHeight")}px`;
    });
    observer.observe(container);
    onCleanup(() => {
      observer.disconnect();
    });
  }
};
export {
  overscroll
};
//# sourceMappingURL=overscroll.js.map
