import { Extension } from '../../types';
export interface SearchWidget {
    /**
     * Hides the search widget and removes most event listeners.
     * @param focusTextarea Whether the editor's `textarea` should gain focus. Defaults to true.
     */
    close: (focusTextarea?: boolean) => void;
    /**
     * Opens the search widget.
     * @param focusInput Whether the widgets's search input should gain focus. Defaults to true.
     */
    open: (focusInput?: boolean) => void;
}
/**
 * Extension that adds a widget for search and replace functionality.
 * This extension needs styles from `solid-prism-editor/search.css`.
 *
 * Once added to an editor the widget can be opened/closed programmatically with the
 * `editor.extensions.searchWidget` object.
 */
export declare const searchWidget: () => Extension;
