/**
 * Array of extensions including (in order):
 * - {@link matchBrackets}
 * - {@link highlightBracketPairs}
 * - {@link matchTags}
 * - {@link highlightMatchingTags}
 * - {@link defaultCommands}
 * - {@link editHistory}
 * - {@link searchWidget}
 * - {@link highlightSelectionMatches}
 * - {@link cursorPosition}
 * - {@link indentGuides}
 * - {@link showInvisibles}
 *
 * Requires styling from `solid-prism-editor/search.css` for the search widget.
 * To highlight selected spaces and tabs, import `solid-prism-editor/invisibles.css`.
 */
declare const basicSetup: import('./types').Extension[];
/**
 * Array of extensions including (in order):
 * - {@link matchBrackets}
 * - {@link highlightBracketPairs}
 * - {@link matchTags}
 * - {@link highlightMatchingTags}
 * - {@link highlightSelectionMatches}
 * - {@link indentGuides}
 * - {@link copyButton}
 * - {@link readOnlyCodeFolding} with {@link tagFolding}, {@link bracketFolding},
 * {@link blockCommentFolding}, and {@link markdownFolding}
 *
 * Intended to be used with read-only editors.
 *
 * Requires styling from `solid-prism-editor/copy-button.css` for the copy button
 * and from `solid-prism-editor/folding.css` for the code folding.
 */
declare const readOnlySetup: import('./types').Extension[];
export { basicSetup, readOnlySetup };
