import { template as template$1, insert, createComponent } from "solid-js/web";
import { createSignal, Show } from "solid-js";
const template = /* @__PURE__ */ template$1("<div class=pce-tooltip style=z-index:5;top:auto;display:flex;overflow-x:clip><div>");
const addTooltip = (editor, element, fixedWidth = true) => {
  const container = template();
  const style = container.style;
  const spacer = container.firstChild;
  const [open, setOpen] = createSignal(false);
  insert(container, element, null);
  if (!fixedWidth) spacer.style.flexShrink = 0;
  return {
    show(above) {
      let cursor = editor.extensions.cursor;
      if (cursor) {
        let {
          left,
          right,
          top,
          bottom,
          height
        } = cursor.getPosition();
        setOpen(true);
        spacer.style.width = (editor.props.rtl ? right : left) + "px";
        let placeAbove = !above == top > bottom && (above ? top : bottom) < container.clientHeight ? !above : above;
        style[placeAbove ? "bottom" : "top"] = height + (placeAbove ? bottom : top) + "px";
        style[placeAbove ? "top" : "bottom"] = "auto";
      }
    },
    hide() {
      setOpen(false);
    },
    element: createComponent(Show, {
      get when() {
        return open();
      },
      children: container
    })
  };
};
export {
  addTooltip
};
//# sourceMappingURL=tooltips.js.map
